//we hacked this file a little bit
//code was getting hard to read
//we blew away some comments (well, most of them) for ease of reading (!)
#include "copyright.h"

#include "utility.h"
#include "filesys.h"
#ifdef CHANGED
#include "openfile.h"
#endif
#include "thread.h"

#define TransferSize 	10 	// make it small, just to be difficult

// Copy a file from UNIX to Nachos
void
Copy(char *from, char *to)
{
    FILE *fp;
    OpenFile* openFile;
    int amountRead, fileLength;
    char data[TransferSize];

    if ((fp = fopen(from, "r")) == NULL) {	 // Open UNIX file
	printf("Copy: couldn't open input file %s\n", from);
	return;
    }

    fseek(fp, 0, 2);		// figure out length of UNIX file
    fileLength = ftell(fp);
    fseek(fp, 0, 0);
    openFile = kernel->fileSystem->Create(NULL, to);
    if (openFile == NULL) {
	printf("Copy: couldn't create output file %s\n", to);
	return;
    }

    while ((amountRead = fread(data, sizeof(char), TransferSize, fp)) > 0)
	openFile->Write(data, amountRead);	// Copy

    delete openFile;
    fclose(fp);
    return;
}

// Print the contents of a Nachos file
void
Print(char *n)
{
    OpenFile *openFile;    
    int amountRead;
    char data[TransferSize];

    openFile = kernel->fileSystem->Open(NULL, n);
    if (openFile == NULL) {
	printf("Print: unable to open file %s\n", n);
	return;
    }
    
    while ((amountRead = openFile->Read(data, TransferSize)) > 0)
	for (int i = 0; i < amountRead; i++)
	    printf("%c", data[i]);

    delete openFile;
    return;
}

#define FileName 	"TestFile"
#define Contents 	"1234567890"
#define ContentSize 	strlen(Contents)
#define FileSize 	(ContentSize * 5000)

// Write a large file, a bit at a time
void 
FileWrite()
{
    OpenFile *openFile;    
    int i, numBytes;

    printf("Performance test, using %s as test file\n", FileName);

    printf("Sequential write of %d byte file, in %d byte chunks\n", 
	FileSize, ContentSize);
    openFile = kernel->fileSystem->Create(NULL, FileName);
    if (openFile == NULL) {
      printf("Perf test: can't create %s\n", FileName);
      return;
    }
    for (i = 0; i < FileSize; i += ContentSize) {
        numBytes = openFile->Write(Contents, ContentSize);
	if (numBytes < 10) {
	    printf("Perf test: unable to write %s\n", FileName);
	    delete openFile;
	    return;
	}
    }
    delete openFile;	// close file
}

// Read a large file, a bit at a time
void 
FileRead()
{
    OpenFile *openFile;    
    char data[ContentSize];
    int i, numBytes;

    printf("Sequential read of %d byte file, in %d byte chunks\n", 
	FileSize, ContentSize);

    openFile = kernel->fileSystem->Open(NULL, FileName);
    if (openFile == NULL) {
	printf("Perf test: unable to open file %s\n", FileName);
	return;
    }
    for (i = 0; i < FileSize; i += ContentSize) {
        numBytes = openFile->Read(data, ContentSize);
	if ((numBytes < 10) || strncmp(data, Contents, ContentSize)) {
	    printf("Perf test: unable to read %s\n", FileName);
	    delete openFile;
	    return;
	}
    }
    delete openFile;	// close file
}

void
PerformanceTest()
{
    printf("Starting file system performance test\n");
    
    FileWrite();
    FileRead();
    bool result = kernel->fileSystem->Remove(NULL, FileName);
    if (!result) {
      printf("Perf test: unable to remove %s\n", FileName);
      return;
    }
}
