#include "syscall.h"
#include "testutil.h"

#define MAXBUF 60
int
main() {

  SpaceId newProc;
  OpenFileId input = StandardInput;
  OpenFileId output = StandardOutput;
  char prompt[3], ch, buffer[MAXBUF], dir[MAXBUF];
  int i,j,foundarg;
  char *progname, *arg;
  int found;

  i=0;
  j=0;
  foundarg=0;

  for(i=0;i<MAXBUF;i++) { buffer[i] = '\0'; dir[i] = '\0'; }

  prompt[0] = '-';
  prompt[1] = '-';
  prompt[3] = ' ';

  for(;;) {

    Print("-- ");
      
    for(i=0; i < MAXBUF; i++){
      buffer[i]=Readch();
      if(buffer[i] == '\n') break;
    }

    if(!i) continue;

    buffer[i] = '\0';
    progname = arg = buffer;
    found = 0;
    i = 0;

    while(!(
	    (buffer[i] <= 'Z' && buffer[i] >= 'A') || 
	    (buffer[i] <= 'z' && buffer[i] >= 'a') || 
	    (buffer[i] <= '9' && buffer[i] >= '0')
	    )
	  && (i<MAXBUF)
	  ){
      i++;
    }

    progname = &buffer[i];
    arg      = &buffer[i];
    for(j = i; j < MAXBUF; j++) {
      if(buffer[j] != ' ') {
	arg++;
	continue;
      }
      buffer[j] = '\0';
      arg++;
      break;
    }

    /* built in cd */

    if (equal("cd", progname) || equal("chdir",progname)) {
      if (Chdir(arg) == -1) {
	Print("cd failed");
	Print(arg);
	Print("\n");
      }
      continue;
    }

    /* built in mkdir */

    if (equal("mkdir",progname)) {
      if(Mkdir(arg) == -1) {
	Print("mkdir failed");
	Print(arg);
	Print("\n");
      }
      continue;
    }

    /* built in rm */

    if (equal("rm",progname)) {
      Remove(arg);
      continue;
    }

    /* built in file creation */

    if (equal("create",progname)) {
      Create(arg);
      continue;
    }

    if (equal("pwd",progname)) {
      Pwd();
      continue;
    }

    if (equal("ls",progname)) {
      Lsdir();
      continue;
    }

    if( i > 0 ) {
      newProc = Exec(buffer);
      if(newProc < 0) continue;
      Join(newProc);
    }
  }
}    











  
